# KIT DE PRECONFIGURATION WORDPRESS DR15

## 1. Contenu de ce répertoire

Ce répertoire contient l'ensemble des éléments permettant d'installer le
Kit de préconfiguration sur un site de l'Offre de service hébergement de sites
WWW du CNRS.

Ce répertoire contient quatre fichiers
* `copie-preconf.tar` : archive tar du site de référence pour le
  kit. Il correspond au site lab0150 de l'Offre de service d'hébergement
  de sites web du CNRS. Son URL est http://preconf.dr15.cnrs.fr
* `copie-preconf.sql`: sauvegarde de la base de données
  de ce même site
* `copie-preconf.php`: script d'installation et de configuration
  pour un nouveau site. Il est installé à la racine du site cible et
  lorsqu'il est lancé, soit depuis un nagigateur, soit depuis un outil en
  ligne de commande comme `wget` ou `curl`, il remplace tout le contenu
  du site par un clone du site de préconfiguration.
* `copie-preconf.sh` : script d'installation pour un nouveau
  site. Il effectue l'ensemble des opérations permettant d'installer le
  kit sur un nouveau site.

## 2. Installation d'un nouveau site

### 2.1 Prérequis

L'installation s'effectue depuis une machine Linux ou Windows dans
l'environnement _bash_ de _Windows Subsystem for Linux_ (WSL)

Les utilitaires suivants sont nécessaires pour pouvoir exécuter
le script d'installation. Ils sont tous disponibles via des packages
RPM ou DEB sur les distributions courantes de Linux.
* `wget`
* `sftp`
* `sshpass`

Les fichiers suivants doivent être présents dans le répertoire courant :
* `copie-preconf.tar`
* `copie-preconf.sql`
* `copie-preconf.php`
* `copie-preconf.sh`


Le site cible doit avoir été créé préalablement via l'Offre de service
`wordpress-php7` et `Standard (2 Go, 1 base)`. Le contact technique
du site cible doit avoir fait suivre à l'équipe SSI en charge de la
configuration de ce site le message "Vos identifants" reçu de la DSI
du CNRS.

Le nom de domaine du site cible tel qu'il apparait dans l'offre doit
être disponible.

**Attention** : rien n'indique le nom du site dans le message
"Vos identifiants" transmis par la DSI. L'installation ne peut pas vérifier
qu'il y a adéquation entre le nom du site et les identifiants. En cas de
confusion, l'installation échouera au moment de la copie du site par SFTP.

### 2.2 Utilisation du script d'installation

L'installation d'un nouveau site se fait via la commande `copie-preconf.sh`.
Inutile de disposer de droits d'administrateur. Dans son utilisation la plus
simple, elle ne prend qu'un seul argument, le nom du site cible. Exemple :

    $ ./copie-preconf site-cible.cnrs.fr

Elle demande de coller les identifiants du site cible puis demande une
confirmation à l'utilisateur :

    $ ./copie-preconf.sh site-cible.cnrs.fr
    >>> Coller ici le contenu du mail "Vos identifiants" reçu
    >>> à la création du site et terminez par un CTRL-D seul sur
    >>> une ligne.
    >>> ---------------------------------------------------------
    
    SFTP
    ====
    Identifiant : lab9999
    Mot de passe : LeMotDePasse
    IP du serveur Web : 195.220.198.90
    Port : 50029
    
    MYSQL
    =====
    Base : lab9999sql0db
    Identifiant : lab9999sql0
    Mot de passe : LeMotDePasse
    Host du serveur Mysql : mysql2.lamp.ods
    Acces phpmyadmin : https://laboffice.lamp.core-clouds.fr/phpMyAdmin/
    
    >>> ---------------------------------------------------------
    Identifiants pour le site sandbox.dr15.cnrs.fr
    
    IP du serveur SFTP:   195.220.198.90
    Port SFTP:            50029
    Identifiant SFTP:     lab9999
    Mot de passe SFTP:    LeMotDePasse
    
    Nom du serveur MySQL: mysql2.lamp.ods
    Base MySQL:           lab9999sql0db
    Identifiant MySQL:    lab9999sql0
    Mot de passe MySQL:   LeMotDePasse
    
    Les identifiants ci-dessus sont-ils corrects [O/n] ? o
    Connected to 195.220.198.90.
    [...]
    Installation effectuée


Elle se termine par le message "Installation effectuée". Si ce message
n'apparait pas, c'est que quelque chose s'est mal passé.

Si les identifiants du site cible ont été sauvegardés dans un fichier
(`fichier-identifiants`) dans l'exemple ci-dessous), il est possible
d'utiliser l'option `-f` du script. Dans ces conditions, les identifiants
ne seront pas demandés :

    $ ./copie-preconf.sh -f fichier-identifiants site-cible.cnrs.fr

Une confirmation sera tout de même demandée à l'utilisateur pour vérifier
que ces identifiants sont corrects. Pour éviter cette question, utiliser
l'option `-y` comme suit :

    $ ./copie-preconf.sh -f fichier-identifiants -y site-cible.cnrs.fr

### 2.3 Installation manuelle

Les différentes opérations effectuées par le script peuvent être effectuées
manuellement en procédant comme suit :

* copier le fichier `copie-preconf.php` dans `copie-preconf.tmp` et éditer
  la section contenant les définitions des paramètres d'accès à la base de
  données du site ainsi que l'adresse IP ou la plage d'adresses IP des
  clients autorisés à effectuer l'installation du site cible.  
* copier par SFTP les fichiers `copie-preconf.tar` et `copie-preconf.sql`
  dans le répertoire `tmp` du site cible
* copier par SFTP le fichier `copie-preconf.tmp` dans le répertoire
  `site-cible.cnrs.fr/www` du site cible
* renommer le fichier `copie-preconf.tmp` en `copie-preconf.php`

Exécuter l'installation du site cible en tapant l'URL
`http://site-cible.cnrs.fr/copie-preconf.php` ou bien via la ligne de
commande :

    $ wget -O - -q http://site-cible.cnrs.fr/copie-preconf.php

L'installation doit afficher `Installation effectuée` pour indiquer
que tout s'est bien passé. Les différents fichiers téléchargés
par SFTP seront effacés.

## 3. Personnalisation du site

Chaque site installé par l'une ou l'autre des méthodes ci-dessous est
opérationnel immédiatement. Ils reprend l'aspect graphique, les
plugins, etc. du site de référence.

Pour commencer à l'utiliser, configurer via phpMySQL l'utilisateur
qui sera l'administrateur du site. Pour ce faire, afficher la table
`wp_users` et modifier la première ligne.

* dans la colonne `user_login`, indiquer l'identifiant de l'administrateur
* dans la colonne `user_nicename`, indiquer également l'identifiant de
  l'administrateur
* dans la colonne `user_email`, indiquer l'adresse mail de l'administrateur
* dans la colonne `display_name`, indiquer le nom et le prénom de
  l'administrateur
* enregistrer les modifications

Ensuite, pour modifier le mot de passe du site, se connecter sur la page
`http://site-cible.cnrs.fr/wp-admin` et cliquez sur "Mot de passe oublié".
Un mail sera envoyé à l'adresse de l'administrateur afin de réinitialiser
le mot de passe.

Dès que cette opération est terminée, le site est prêt à l'emploi par le
laboratoire. Lui transmettre :
* les identifiants du compte utilisateur
* la documentation `Comment utiliser la préconfiguration Wordpress DR15.docx`

## 4. Installation en masse

Pour installer ou à réinstaller plusieurs sites simultanément, procéder ainsi :
* créer pour chaque site un fichier qui porte son nom et l'extension `.id`, par
  exemple `site1.cnrs.fr.id`, `site2.cnrs.fr.id`, ..., `siteN.cnrs.fr.id`
* faire un copier/coller dans chacun de ces fichiers des identifiants du site
  en question
* lancer les commandes :

```
$ dos2unix *.id
$ for $i in *.id; do ./copie-preconf.sh -f $i -y $(basename $i .id); done
```

